import com.sun.jna.Library;
import com.sun.jna.Native;
import com.sun.jna.Pointer;

public interface X2CANLibrary extends Library {
    X2CANLibrary INSTANCE = (X2CANLibrary) Native.load(("X2CAN_3th_dll_x64"), X2CANLibrary.class);

    /************************************************************************************************************* */
    /************************************************************************************************************* */
    /************************************************************************************************************* */
    //triple
    Pointer USB2CAN_TRIPLE_PrepareAdapter(int port_number);

    void USB2CAN_TRIPLE_PrepareAdapterSpeedC1(Pointer adapter, int can_speed, boolean listen_only);

    void USB2CAN_TRIPLE_PrepareAdapterSpeedC2(Pointer adapter, int speed, boolean listen_only);

    void USB2CAN_TRIPLE_PrepareAdapterSpeedC3(Pointer adapter, int speed, boolean listen_only, boolean esi,
            boolean iso_crc);

    boolean USB2CAN_TRIPLE_OpenSimple(int speed);

    void USB2CAN_TRIPLE_SelectActualAdapter(Pointer adapter);

    boolean USB2CAN_TRIPLE_Close();

    int USB2CAN_TRIPLE_FindCOM();

    boolean USB2CAN_TRIPLE_SendExtendedMessage(int StandardId, int ExtendedId, boolean RTR, byte Length,
            byte[] Data);

    boolean USB2CAN_TRIPLE_SendExtendedMessage29(int ExtendedId, boolean RTR, byte Length, byte[] Data);

    boolean USB2CAN_TRIPLE_SendStandardMessage(int StandardId, boolean RTR, byte Length, Pointer Data);

    void USB2CAN_TRIPLE_SetTimeStampMode(boolean mode);

    boolean USB2CAN_TRIPLE_SendCANMessageP(Pointer message);

    int USB2CAN_TRIPLE_GetRXBufferLength();

    boolean USB2CAN_TRIPLE_GetMessage11_18(Pointer StExt, Pointer StandardId, Pointer ExtendedId, Pointer RTR,
            Pointer Length, Pointer Data);

    void USB2CAN_TRIPLE_SetUsrNominalBitTime(int NBRP, int NTSEG1, int NTSEG2, int NSJW);

    void USB2CAN_TRIPLE_SetUsrDataBitTime(int DBRP, int DTSEG1, int DTSEG2, int DSJW, int TDCO, int TDCV, int TDCMOD);

    void USB2CAN_TRIPLE_DestroyAdapter(Pointer adapter);

    void USB2CAN_TRIPLE_SelectActualAdapterAccess(Pointer adapter);

    void USB2CAN_TRIPLE_UnselectActualAdapterAccess();

    boolean USB2CAN_TRIPLE_Reset();

    boolean USB2CAN_TRIPLE_SendStandadMessage(int StandardId, boolean RTR, byte Length, Pointer Data);

    boolean USB2CAN_TRIPLE_SendExtendedMessage(int StandardId, int ExtendedId, boolean RTR, byte Length, Pointer Data);

    boolean USB2CAN_TRIPLE_SendExtendedMessage29(int ExtendedId, boolean RTR, byte Length, Pointer Data);

    boolean USB2CAN_TRIPLE_GetMessage29(Pointer StExt, Pointer Id, Pointer RTR, Pointer Length, Pointer Data);

    boolean USB2CAN_TRIPLE_GetCANMessage(Pointer message);

    boolean USB2CAN_TRIPLE_GetCANTXMessage(Pointer message);

    int USB2CAN_TRIPLE_GetTXBufferLength();

    int USB2CAN_TRIPLE_GetTXBufferLengthByPort(int port);

    void USB2CAN_TRIPLE_ClearBuffers();

    boolean USB2CAN_TRIPLE_WaitForRxMessage(int timeout);

    boolean USB2CAN_TRIPLE_WaitForTxMessage(int timeout);

    byte USB2CAN_TRIPLE_GetREC();

    byte USB2CAN_TRIPLE_GetTEC();

    int USB2CAN_TRIPLE_GetRST();

    void USB2CAN_TRIPLE_EnableReadTEC(boolean enable);

    void USB2CAN_TRIPLE_EnableReadREC(boolean enable);

    byte USB2CAN_TRIPLE_GetTECByPort(int port);

    byte USB2CAN_TRIPLE_GetRECByPort(int port);

    boolean USB2CAN_TRIPLE_GetFWVersion();

    int USB2CAN_TRIPLE_GetFWVersionNumber();

    void USB2CAN_TRIPLE_SetBufferMode(int mode);

    boolean USB2CAN_TRIPLE_SendBufferMode();

    // Command
    boolean USB2CAN_TRIPLE_SendGetBufferMode();

    boolean USB2CAN_TRIPLE_SendGetSerNum();

    Pointer USB2CAN_TRIPLE_GetSerialNumber();

    int USB2CAN_TRIPLE_IsFDCANSupported();

    boolean USB2CAN_TRIPLE_ForwardPort2(boolean enable, int port);

    boolean USB2CAN_TRIPLE_ForwardPort3(boolean enable, int port);

    boolean USB2CAN_TRIPLE_IsForwardPort2Enabled();

    boolean USB2CAN_TRIPLE_IsForwardPort3Enabled();

    int USB2CAN_TRIPLE_GetForwardPort2Number();

    int USB2CAN_TRIPLE_GetForwardPort3Number();

    void USB2CAN_TRIPLE_SetBusLoadLimitC1(double limit);

    double USB2CAN_TRIPLE_GetBusLoadLimitC1();

    void USB2CAN_TRIPLE_SetBusLoadLimitC2(double limit);

    double USB2CAN_TRIPLE_GetBusLoadLimitC2();

    void USB2CAN_TRIPLE_SetBusLoadLimitC3(double limit);

    double USB2CAN_TRIPLE_GetBusLoadLimitC3();

    boolean USB2CAN_COMBO_GetFaultInjectorMode();

    boolean USB2CAN_COMBO_GetFaultInjectorModeActive();

    boolean USB2CAN_COMBO_SingleWireMode(boolean high_speed);

    boolean USB2CAN_COMBO_GetLowSpeedError();

    boolean USB2CAN_COMBO_SingleWireHighSpeedFeedback();

    boolean USB2CAN_TRIPLE_SetFaultInjectionMode();

    // reads the specified buffer from the converter and stores the data in the
    // internal API structure. The individual items of the buffer structure can then
    // be read using the Get functions.
    boolean USB2CAN_TRIPLE_HWSync_Read(int index);

    // index -index of the sending buffer (0.15) that is enabled or disabled
    boolean USB2CAN_TRIPLE_HWSync_Enable(int index);

    boolean USB2CAN_TRIPLE_HWSync_Disable(int index);

    int USB2CAN_TRIPLE_HWSync_GetPeriode(int index);

    int USB2CAN_TRIPLE_HWSync_GetFlags(int index);

    int USB2CAN_TRIPLE_HWSync_GetChecksumMode(int index);

    int USB2CAN_TRIPLE_HWSync_GetToggleBit(int index);

    // enables or disables the generation of messages from buffers at once using the
    // mask
    boolean USB2CAN_TRIPLE_HWSync_DisableByMask(int mask);

    boolean USB2CAN_TRIPLE_HWSync_EnableByMask(int mask);

    // Sets the HW gatewaye item. For this function, the port and the st_ext flag
    // are part of the identifier. It is recommended to use the
    // USB2CAN_TRIPLE_GWSetItem function .
    boolean USB2CAN_TRIPLE_GWSetItem2(int index, int id, int mask);

    // The identifier and mask are used to determine if the message is a forwarded
    // message. The mask is applied to both the specified
    // item identifier and the received message identifier. If the results match,
    // the message is forwarded.
    boolean USB2CAN_TRIPLE_GWSetItem(int index, int id, int mask, boolean st_ext, int port);

    // size - gateway table size (number of items)
    // mode1/mode2 - forwarding mode 0-forward all. forward messages from a table,
    // 2-dont forward messages from a table
    boolean USB2CAN_TRIPLE_GWSetTableSize(byte size, byte mode1, byte mode2, byte port_maping);

    boolean USB2CAN_TRIPLE_CheckUSB2CAN();

    /************************************************************************************************************* */
    /************************************************************************************************************* */
    /************************************************************************************************************* */
    // X2CAN
    Pointer X2CAN_PrepareMessage();

    Pointer X2CAN_PrepareStandardMessage(int StandardId, boolean RTR, byte Length, int Port, Pointer Data);

    Pointer X2CAN_PrepareExtendedMessage(int StandardId, int ExtendedId, boolean RTR, byte Length, int Port,
            Pointer Data);

    Pointer X2CAN_PrepareExtended29Message(int ExtendedId, boolean RTR, byte Length, int Port, Pointer Data);

    // Nastaveni dat ze zadaneho pole, jako delka je pouzita hodnota ulozena ve
    // zprave
    boolean X2CAN_SetData(Pointer Message, Pointer Data);

    // Nastaveni dat ze zadaneho pole, jako delka je pouzita hodnota parametru
    // Length
    boolean X2CAN_SetDataAndLength(Pointer Message, byte Length, Pointer Data);

    // Individualni nastaveni datoveho bajtu, vraci false pokud je index mimo rozah
    // nebo je zadan index FD dat a zprava neni nastavena jako FD - nema alokovanou
    // pamet
    boolean X2CAN_SetDataByte(Pointer Message, byte Index, byte Data);

    // Nataveni priznaku Baud rate switch
    boolean X2CAN_SetBRS(Pointer Message, boolean BRS);

    // Nastaveni priznaku FD zpravy - nealokuje ale pamet pro FD data
    boolean X2CAN_SetFD(Pointer Message, boolean FD);

    // Nastaveni delky - nealokuje ale pamet pro FD data
    boolean X2CAN_SetLength(Pointer Message, byte Length);

    // Vraci hodnotu identifikatoru
    int X2CAN_GetStandardId(Pointer Message);

    int X2CAN_GetExtendedId(Pointer Message);

    int X2CAN_GetExtendedId29(Pointer Message);

    // Test RTR flag
    boolean X2CAN_IsRTR(Pointer Message);

    // Test flag - 29b Id
    boolean X2CAN_IsExt(Pointer Message);

    // Test CAN FD zpr8va
    boolean X2CAN_IsFD(Pointer Message);

    // Test Baud rate switch
    boolean X2CAN_GetBRS(Pointer Message);

    // Vraci port
    int X2CAN_GetPort(Pointer Message);

    // Vraci zadany datovy bajt, pokud je napriklad index mimo rozsah, nebo delku
    // zpravy, vraci 0x00
    byte X2CAN_GetData(Pointer Message, byte Index);

    // Vraci delku zpravy
    byte X2CAN_GetLength(Pointer Message);

    // Precteni dat z CAN zpravy - 8 datovych bajtu, vraci pocet prectenych bajtu
    byte X2CAN_GetDataClassic(Pointer Message, Pointer Data);

    // Precteni dat z CAN FD zpravy - az 56 dalsich datovych bajtu, vraci pocet
    // prectenych bajtu
    byte X2CAN_GetDataFD(Pointer Message, Pointer Data);

    // Dealokace pameti zpravy
    void X2CAN_DestroyMessage(Pointer Message);

    // boolean USB2CAN_TRIPLE_GetCANMessage(CAN_MESSAGE message);
    // boolean USB2CAN_TRIPLE_SendCANMessage2(Pointer adapter,CAN_MESSAGE message);
    // boolean USB2CAN_TRIPLE_SendCANMessage(CAN_MESSAGE message);
}
