import com.sun.jna.Pointer;
import com.sun.jna.Memory;
import java.util.Scanner;

public class usb2canTriple {

    public static void main(String[] args) throws InterruptedException {
        X2CANLibrary x2can = X2CANLibrary.INSTANCE;
        
        Scanner s = new Scanner(System.in);
        System.out.println("Press enter to continue.....");
        s.nextLine();   

        Pointer adapter = x2can.USB2CAN_TRIPLE_PrepareAdapter( 9);

        x2can.USB2CAN_TRIPLE_PrepareAdapterSpeedC1(adapter, 250, false);
        x2can.USB2CAN_TRIPLE_PrepareAdapterSpeedC2(adapter, 250, false);
        x2can.USB2CAN_TRIPLE_PrepareAdapterSpeedC3(adapter, 2501000, false, false, true);
        x2can.USB2CAN_TRIPLE_SelectActualAdapter(adapter);
        x2can.USB2CAN_TRIPLE_SetTimeStampMode(false);
        x2can.USB2CAN_TRIPLE_SetBufferMode(0x00);
        if(x2can.USB2CAN_TRIPLE_OpenSimple(250))
        {
            System.out.println("Triple opened");
        }

        // priprava pameti pro prijem dat
        Pointer Data = new Memory(8);
        Pointer DataFD = new Memory(64);
        // standart message
        
        Pointer MessageTx;
        Pointer MessageTx2;
        Pointer MessageTx3FD;
        // pouziva se pro odeslani i prijem
        Data.setByte(0, (byte) 0x11);
        Data.setByte(1, (byte) 0x22);
        Data.setByte(2, (byte) 0x33);
        Data.setByte(3, (byte) 0x44);
        Data.setByte(4, (byte) 0x55);
        Data.setByte(5, (byte) 0x66);
        Data.setByte(6, (byte) 0x77);
        Data.setByte(7, (byte) 0x88);

        DataFD.setMemory(0,32, (byte)0x11);
        DataFD.setMemory(32,32, (byte)0x22);

        MessageTx = x2can.X2CAN_PrepareStandardMessage(11, false, (byte) 8, 1, Data);
        MessageTx2 = x2can.X2CAN_PrepareExtended29Message(11, false, (byte) 8, 1, Data);
        MessageTx3FD = x2can.X2CAN_PrepareExtended29Message(11, false, (byte) 64, 3, DataFD);
        
        x2can.USB2CAN_TRIPLE_SendCANMessageP(MessageTx);
        x2can.USB2CAN_TRIPLE_SendCANMessageP(MessageTx2);
        x2can.USB2CAN_TRIPLE_SendCANMessageP(MessageTx3FD);


        x2can.X2CAN_SetDataByte(MessageTx, (byte)0, (byte)255);
        x2can.USB2CAN_TRIPLE_SendCANMessageP(MessageTx);

        x2can.X2CAN_DestroyMessage(MessageTx);
        x2can.X2CAN_DestroyMessage(MessageTx2);
        x2can.X2CAN_DestroyMessage(MessageTx3FD);
        
        Pointer MessageRx = x2can.X2CAN_PrepareMessage();

        Boolean run = true; 

        while (run) {
            if (x2can.USB2CAN_TRIPLE_WaitForRxMessage(100000)) {
                while ((x2can.USB2CAN_TRIPLE_GetCANMessage(MessageRx))) {
                    System.out.print("\n-----------> Recieved message : ");
                    
                    System.out.println(x2can.X2CAN_GetExtendedId29(MessageRx));

                    if(x2can.X2CAN_GetExtendedId29(MessageRx)==100)
                        run=false;

                    System.out.print("  RTR : ");
                    System.out.print(x2can.X2CAN_IsRTR(MessageRx));

                    System.out.print("  Format : ");
                    System.out.print(x2can.X2CAN_IsExt(MessageRx));

                    System.out.print("  FD : ");
                    System.out.println(x2can.X2CAN_IsFD(MessageRx));

                    System.out.print("  Port : ");
                    System.out.println(x2can.X2CAN_GetPort(MessageRx));
                    
                    System.out.print("  Data Lenght : ");
                    System.out.println(x2can.X2CAN_GetLength(MessageRx));

                    System.out.print("  ");
                    for (byte val = 0; val < x2can.X2CAN_GetLength(MessageRx); val++) 
                    {
                        System.out.printf(String.format("%02X,", x2can.X2CAN_GetData(MessageRx, val)));
                    }                  
                }
            }
            else
            {
                 System.out.println("no message recieved within 100 sec");
                 break;
            }
            
        }
        
        x2can.X2CAN_DestroyMessage(MessageRx);
        x2can.USB2CAN_TRIPLE_Close();

    }
}

/*
 * Spousteni z konzole
 * e:\David\pp2can\API_v2_5_c\_bin_64_\Release>java -Djava.library.path=e:\David\pp2can\API_v2_5_c\_bin_64_\Release -jar example.jar
 */